function Est32700_ValidadeDeProdutos_Controller(EstUtil, ScreenService, General, templateManager,ZhFilterPreferences, Est32700_ValidadeDeProdutos_Service) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        let rowsToSet  = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = [success.dataset.filial[0].CDFILIAL];
            rowsToSet.NMFILIAL = [success.dataset.filial[0].NMFILIAL];
            ZhFilterPreferences.openFilterWidget(widget,rowsToSet).then(function(success) {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
                this.verAlmoxEstoque(templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions'));
            }.bind(this));
        }.bind(this));
        
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.getFilialLogada = function() {
    var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
	    ];
    return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    this.verAlmoxEstoque = function(args){
        
        
        let widget = templateManager.container.getActiveWidget();
        
        if(widget.name != 'zhFilterPreferencesSelectConditions'){
            widget = args;
        }
        
        Est32700_ValidadeDeProdutos_Service.getParamFilialData(widget).then(() =>{
            
            let almoxField = widget.getField('DSALMOXARIFE');
            let LocalField = widget.getField('DSLOCALESTOQ');
            let cdAlmoxField = widget.getField('CDALMOXARIFE');
            let cdLocalEstField = widget.getField('CDLOCALESTOQ');
            
            widget.currentRow.CDALMOXARIFE = cdAlmoxField.value() ? cdAlmoxField.value() : "";
            
            //verifica almoxarifado
            if(widget.currentRow.IDUTILALMOX === 'N'){
                almoxField.readOnly = true;
                almoxField.clearValue();
                cdAlmoxField.clearValue(" ");
                delete almoxField.validations;
                
            }else{
                almoxField.readOnly = false;
                almoxField.validations = {"required": {"message": "Campo Obrigatório"}};
            }
            
            //verifica local do estoque
            if(widget.currentRow.IDUTILLCESTQ === 'N'){
                LocalField.readOnly = true;
                LocalField.clearValue();
                cdLocalEstField.clearValue(" ");
            }else{
                cdLocalEstField.clearValue();
                LocalField.readOnly = false;
            }
            
            this.checkDataForm(widget);
            
        });
    };
    
	// Realiza a limpeza de valores do filtro caso a filial seja mudada
    this.clearFieldsOnChangeFilial = function(widget){
        let fields = [
            "CDALMOXARIFE",
            "DSALMOXARIFE",
            "CDLOCALESTOQ",
            "DSLOCALESTOQ",
            "VALIDADE",
            "ENTREGA",
            "CDPRODINI",
            "NMPRODINI",
            "CDPRODFIN",
            "NMPRODFIN"
            ];
        
        fields.forEach((field)=>{
            let fieldToClear = widget.getField(field);
            fieldToClear.clearValue("");
            
            if(fieldToClear.name === "DSALMOXARIFE" || fieldToClear.name === "DSLOCALESTOQ" ||
            fieldToClear.name === "NMPRODINI" || fieldToClear.name === "NMPRODFIN"){
                fieldToClear.reload();
            }
        });
    };
    
    this.checkDataForm = function(args){
        
        let widget = templateManager.container.getActiveWidget();
        
        if(widget.name != 'zhFilterPreferencesSelectConditions'){
            widget = args;
        }
        
        let LocalField = widget.getField('DSLOCALESTOQ');
        let cdLocalEstField = widget.getField('CDLOCALESTOQ');
        
        if(widget.currentRow.IDUTILALMOX === 'S' && widget.currentRow.IDUTILLCESTQ === 'S'){
            if(widget.currentRow.CDALMOXARIFE !== ""){
                LocalField.validations = {"required": {"message": "Campo Obrigatório"}};
                LocalField.readOnly = false;
            }else{
                LocalField.clearValue();
                cdLocalEstField.clearValue();
                delete LocalField.validations;
                LocalField.readOnly = true;
            }
            
            LocalField.reload();
        }
        
        if(widget.currentRow.IDUTILALMOX === 'S' && widget.currentRow.IDUTILLCESTQ === 'N'){
            if(widget.currentRow.CDALMOXARIFE !== ""){
                cdLocalEstField.value(' ');
            }else{
                cdLocalEstField.clearValue("");
            }
        }
        
    };
    
    // redefine filtro com parametros corretos a serem enviados para o backend
    this.changeFilter = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        
        var tamanhoMask = getLocalVar('CDPICTPROD').replace(/\./g,'').length;
        filterRow.CDPRODFIN = filterRow.CDPRODFIN ? filterRow.CDPRODFIN : "";
        var tamanho = tamanhoMask - filterRow.CDPRODFIN.length;
        
        for(var i = 0; i < tamanho; i++){
        	filterRow.CDPRODFIN = filterRow.CDPRODFIN+"Z";
        }

        var filtro= [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": filterRow.CDFILIAL
            },
            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : " "
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : " "
            },
            {
                "name":"DTVALIINI",
                "operator":"=",
                "value": filterRow.VALIDADE ? filterRow.VALIDADE.start : null
            },
            {
                "name":"DTVALIFIN",
                "operator":"=",
                "value": filterRow.VALIDADE ? filterRow.VALIDADE.end : null
            },
            {
                "name":"DTEMIINI",
                "operator":"=",
                "value": filterRow.ENTREGA ? filterRow.ENTREGA.start : null
            },
            {
                "name":"DTEMIFIN",
                "operator":"=",
                "value": filterRow.ENTREGA ? filterRow.ENTREGA.end : null
            },
            {
                "name":"CDPRODINI",
                "operator":"=",
                "value": filterRow.CDPRODINI ? filterRow.CDPRODINI : null
            },
            {
                "name":"CDPRODFIN",
                "operator":"=",
                "value": filterRow.CDPRODFIN ? filterRow.CDPRODFIN : null
            },
            {
                "name":"NMPRODINI",
                "operator":"=",
                "value": filterRow.NMPRODINI ? filterRow.NMPRODINI : null
            },
            {
                "name":"NMPRODFIN",
                "operator":"=",
                "value": filterRow.NMPRODFIN ? filterRow.NMPRODFIN : null
            }
        ];
        
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
    this.checkProductRange = function(field) {
        var currentRow = field.widget.currentRow;
      
        if(currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if(!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        } 
    };
}


Configuration(function(ContextRegister){
    ContextRegister.register('Est32700_ValidadeDeProdutos_Controller', Est32700_ValidadeDeProdutos_Controller);
});