package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MainPage extends PageBase {
    //Mapping:
    By menuPrincipal = By.xpath("//*[@data-zh-id='zh-header-menu-button']//a");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By usernameLoginInfoTextArea = By.xpath("//div[@class='zh-header-info']");
    By reportIssueLink = By.xpath("//a[@href='/bug_report_page.php']");

    //COMPRAS:
    By Compras = By.xpath("//span[text() = 'Compras']");

    //TELAS DENTRO DE SOLICITAÇÃO DE COMPRAS:
    By SolicitacaoCompras = By.xpath("//span[text() = 'Solicitação de Compras']");
    By LancamentoDaSolicitacaoDeCompras = By.xpath("//span[text() = 'Lançamento da Solicitação de Compras']");

    //ESTOQUE:
    By Estoque = By.xpath("//*[@data-zh-id='90884303627023268473090']//span[text() = 'Estoque']");
    By AjusteIventario = By.xpath("//*[@data-zh-id='9088430366648752383094']//span[text() = 'Ajuste de Inventário']");
    By implantacaoDeEstoque = By.xpath("//*[@data-zh-id='9088430363559080913095']//span[text() = 'Implantação de Estoque']");
    By Relatorios = By.xpath("//*[@data-zh-id='90884303642152590193144']//span[text() = 'Relatórios']");
    By PosicaoDeEstoque = By.xpath("//*[@data-zh-id='90884303631807304033145']//span[text() = 'Posição de Estoque']");
    By MovimentacaoDeEstoque = By.xpath("//*[@data-zh-id='90884303637956338223148']//span[text() = 'Movimentação de Estoque']");

    //Actions
    public String retornaUsernameDasInformacoesDeLogin(){
        return getText(usernameLoginInfoTextArea);
    }
    public void clicarEmReportIssue(){
        click(reportIssueLink);
    }
        public void clicarEmMenuPrincipal(){
            waitForElement(usernameLoginInfoTextArea);
            waitForVisibilityOfElementLocated(menuPrincipal);
            click(menuPrincipal);
        }
        public void clicarEmEstoque(){
            waitForVisibilityOfElementLocated(Estoque);
            click(Estoque);
        }
        public void clicarEmCompras(){
            waitForVisibilityOfElementLocated(Compras);
            click(Compras);
        }
    //CMP:
        public void clicarEmLancamentoDaSolicitacaoDeCompras(){
        waitForVisibilityOfElementLocated(SolicitacaoCompras);
        click(SolicitacaoCompras);
        click(LancamentoDaSolicitacaoDeCompras);
    }
    //EST:
        public void clicarEmAjusteDeIventario(){
        waitForVisibilityOfElementLocated(AjusteIventario);
        click(AjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
        public void clicarEmImplantacaoEstoque(){
        waitForVisibilityOfElementLocated(implantacaoDeEstoque);
        click(implantacaoDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
        public void clicarEmPosicaDeEstoque(){
        waitForVisibilityOfElementLocated(Relatorios);
        click(Relatorios);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(PosicaoDeEstoque);
        click(PosicaoDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        }
        public void clicarEmMovimentacaoDeEstoque(){
            waitForVisibilityOfElementLocated(Relatorios);
            click(Relatorios);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(MovimentacaoDeEstoque);
            click(MovimentacaoDeEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);

        }

}
